package cn.wangdian.erp.demo;

import cn.wangdian.erp.sdk.Client;
import cn.wangdian.erp.sdk.Pager;
import cn.wangdian.erp.sdk.api.setting.SettingAPI;
import cn.wangdian.erp.sdk.api.setting.dto.QueryWarehouseRequest;
import cn.wangdian.erp.sdk.api.setting.dto.QueryWarehouseResponse;
import cn.wangdian.erp.sdk.impl.ApiFactory;
import cn.wangdian.erp.sdk.impl.DefaultClient;

public class Setting
{

	public static void main(String[] args)
	{
		// Client client = DefaultClient.get("wdtapi3", "test", "test");
		Client client = DefaultClient.get("wdterp30", "http://169.254.166.15:30000/", "POS",
				"c1fbdd70132de9300d23a05a5f63e150:cc169a95acdaa9ffaed4e9d59f93efaa");
		SettingAPI settingApi = ApiFactory.get(client, SettingAPI.class);

		queryWarehouse(settingApi);
	}

	private static void queryWarehouse(SettingAPI settingApi)
	{
		QueryWarehouseRequest request = new QueryWarehouseRequest();
		request.setWarehouseNo("1001");
		// request.setWarehouseName("LJ测试仓");
		// request.setType(QueryWarehouseRequest.TYPE_INNER);
		// request.setSubType(QueryWarehouseRequest.SUB_TYPE_DEFAULT);

		QueryWarehouseResponse response = settingApi.queryWarehouse(request, new Pager(2, 0, true));
		if (response.getTotal() == null || response.getTotal() == 0)
		{
			System.out.println("No eligible results!");
			return;
		}

		System.out.print("total : " + response.getTotal());
		for (QueryWarehouseResponse.WarehouseDto warehouseDto : response.getWarehouseList())
		{
			System.out.print(" warehouse no : " + warehouseDto.getWarehouseNo() + " ");
		}
	}
}
