package cn.wangdian.erp.demo;

import cn.wangdian.erp.sdk.Client;
import cn.wangdian.erp.sdk.Pager;
import cn.wangdian.erp.sdk.WdtErpException;
import cn.wangdian.erp.sdk.api.wms.StockAPI;
import cn.wangdian.erp.sdk.api.wms.dto.PdOrderCreateRequest;
import cn.wangdian.erp.sdk.api.wms.dto.PdOrderCreateRequest.DetailDto;
import cn.wangdian.erp.sdk.api.wms.stockin.dto.CreateOtherStockinRequest;
import cn.wangdian.erp.sdk.api.wms.dto.StockSearchRequest;
import cn.wangdian.erp.sdk.api.wms.dto.StockSearchResponse;
import cn.wangdian.erp.sdk.api.wms.dto.TransferOrderCreateRequest;
import cn.wangdian.erp.sdk.api.wms.dto.TransferOrderCreateResponse;
import cn.wangdian.erp.sdk.impl.ApiFactory;
import cn.wangdian.erp.sdk.impl.DefaultClient;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

public class Stock
{
	public static void main(String[] args) throws IOException, WdtErpException
	{
		// Client client = DefaultClient.get("wdtapi3", "test", "test");
		Client client = DefaultClient.get("wdterp30", "http://192.168.1.135:30000/", "zyOther",
				"423c25002f36c7445ccd7742ea5d1be4:8f034c5a36d5749a438951cde1963f2a");
		StockAPI stockAPI = ApiFactory.get(client, StockAPI.class);

		// testStockSpecSearch(stockAPI);
		// testCreatePdOrder(stockAPI);
		testTransferOrderCreate(stockAPI);

	}

	private static void testStockSpecSearch(StockAPI stockApi)
	{
		StockSearchRequest request = new StockSearchRequest();

		request.setSpecNos(Arrays.asList("daba3", "daba4"));
		request.setWarehouseNo("pos");
		// request.setStartTime("2019-09-01");
		// request.setEndTime("2019-09-20");

		StockSearchResponse response = stockApi.search(request, new Pager(1, 0, true));

		if (response.getTotal() <= 0)
		{
			System.out.println("No eligible results! ");
			return;
		}

		List<StockSearchResponse.StockSearchDto> dtos = response.getStockSearchDtos();
		System.out.println("total: " + response.getTotal() + " first spec_no:" + dtos.get(0).getSpecNo());
	}

	private static void testCreatePdOrder(StockAPI stockApi)
	{
		PdOrderCreateRequest.OrderDto orderDto = new PdOrderCreateRequest.OrderDto();
		orderDto.setDefectMode(PdOrderCreateRequest.OrderDto.DEFECT_MODE_NORMAL);
		orderDto.setWarehouseNo("1001");
		orderDto.setRemark("API TEST");

		PdOrderCreateRequest.DetailDto detailDto = new PdOrderCreateRequest.DetailDto();
		detailDto.setSpecNo("PC_2018");
		detailDto.setDefect(false);
		detailDto.setNewNum("5");
		detailDto.setRemark("detail remark");

		List<DetailDto> detailList = new ArrayList<DetailDto>();
		detailList.add(detailDto);

		Map<String, Object> response = stockApi.createPdOrder(orderDto, detailList);

		// success
		if (response != null)
			System.out.println(response);
	}

	private static void testTransferOrderCreate(StockAPI stockApi)
	{
		TransferOrderCreateRequest.orderInfoDto orderInfo = new TransferOrderCreateRequest.orderInfoDto();
		TransferOrderCreateRequest.detailDto detailDto1 = new TransferOrderCreateRequest.detailDto();
		TransferOrderCreateRequest.detailDto detailDto2 = new TransferOrderCreateRequest.detailDto();

		orderInfo.setFromWarehouseNo("lz");
		orderInfo.setToWarehouseNo("jziyy");
		orderInfo.setMode(3);
		orderInfo.setRemark("调拨单新建");
		detailDto1.setNum("1");
		detailDto1.setSpecNo("lz11");
		detailDto2.setNum("3");
		detailDto2.setSpecNo("lz13");
		List<TransferOrderCreateRequest.detailDto> detailList = new ArrayList<>();
		detailList.add(detailDto1);
		detailList.add(detailDto2);
		TransferOrderCreateResponse response = stockApi.createTransferOrder(orderInfo, detailList, true);
		response.toString();

	}

}
