package cn.wangdian.erp.demo;

import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import cn.wangdian.erp.sdk.Client;
import cn.wangdian.erp.sdk.Pager;
import cn.wangdian.erp.sdk.api.wms.stockin.dto.CreateTransferStockinRequest;
import cn.wangdian.erp.sdk.api.wms.stockout.StockoutAPI;
import cn.wangdian.erp.sdk.api.wms.stockout.dto.CreateOtherStockoutRequest;
import cn.wangdian.erp.sdk.api.wms.stockout.dto.CreateOtherStockoutResponse;
import cn.wangdian.erp.sdk.api.wms.stockout.dto.CreateTransferStockoutRequest;
import cn.wangdian.erp.sdk.api.wms.stockout.dto.CreateTransferStockoutResponse;
import cn.wangdian.erp.sdk.api.wms.stockout.dto.ProcessStockoutRequest;
import cn.wangdian.erp.sdk.api.wms.stockout.dto.ProcessStockoutResponse;
import cn.wangdian.erp.sdk.api.wms.stockout.dto.SalesStockoutRequest;
import cn.wangdian.erp.sdk.api.wms.stockout.dto.SalesStockoutResponse;
import cn.wangdian.erp.sdk.impl.ApiFactory;
import cn.wangdian.erp.sdk.impl.DefaultClient;

public class Stockout
{
	public static void main(String[] args)
	{
		// Client client = DefaultClient.get("wdtapi3", "test", "test");
		Client client = DefaultClient.get("wdterp30", "http://192.168.1.135:30000/", "zyOther",
				"423c25002f36c7445ccd7742ea5d1be4:8f034c5a36d5749a438951cde1963f2a");
		StockoutAPI stockoutAPI = ApiFactory.get(client, StockoutAPI.class);
		testCreateOtherOutOrder(stockoutAPI);
		// searchProcessStockout(stockoutAPI);
		// querySalesStockout(stockoutAPI);
		// testCreateTransferOrder(stockoutAPI);
	}

	private static void querySalesStockout(StockoutAPI stockoutApi)
	{
		SalesStockoutRequest request = new SalesStockoutRequest();
		request.setSrcOrderNo("JY201911190093");
		// request.setStockoutNo("CK2019112057");
		// request.setWarehouseNo("1001");
		// request.setStatusType(SalesStockoutRequest.STATUS_TYPE_CONSIGNED);
		// request.setStartTime("2019-11-10 00:00:00");
		// request.setEndTime("2019-11-21 00:00:00");
		// request.setPositionSort(false);

		SalesStockoutResponse response = stockoutApi.querySales(request, new Pager(2, 0, true));
		Integer total = response.getTotal();
		if (total == null || total == 0)
		{
			System.out.println("No eligible results!");
			return;
		}

		System.out.print("total : " + total);
		for (SalesStockoutResponse.OrderInfoDto orderInfo : response.getOrderList())
		{
			System.out.println(" trade no : " + orderInfo.getTradeNo() + " first detail spec no: "
					+ orderInfo.getDetailList().get(0).getSpecNo());
		}
	}

	private static void searchProcessStockout(StockoutAPI stockoutApi)
	{
		ProcessStockoutRequest request = new ProcessStockoutRequest();
		request.setProcessNo("PS2020062202");
		ProcessStockoutResponse response = stockoutApi.searchProcess(request, new Pager(50, 0, true));

	}

	private static void testCreateOtherOutOrder(StockoutAPI stockoutAPI)
	{
		CreateOtherStockoutRequest request = new CreateOtherStockoutRequest();
		CreateOtherStockoutRequest.GoodsList inrequest1 = new CreateOtherStockoutRequest.GoodsList();
		// CreateOtherStockoutRequest.GoodsList inrequest2 = new
		// CreateOtherStockoutRequest.GoodsList();
		request.setWarehouseNo("1001");
		request.setOuterNo("CG201911286258");
		request.setRemark("测试1");
		request.setReason("1");
		inrequest1.setSpecNo("PC_2016");
		inrequest1.setPositionNo("J-3");
		inrequest1.setNum(BigDecimal.valueOf(3));
		List<CreateOtherStockoutRequest.GoodsList> list = new ArrayList<>();
		list.add(inrequest1);
		request.setGoodsList(list);

		CreateOtherStockoutResponse response = stockoutAPI.createOtherOutOrder(request);
		response.toString();
	}

	private static void testCreateTransferOrder(StockoutAPI stockoutAPI)
	{
		CreateTransferStockoutRequest.orderInfoDto orderInfo = new CreateTransferStockoutRequest.orderInfoDto();
		CreateTransferStockoutRequest.detailDto detailDto1 = new CreateTransferStockoutRequest.detailDto();

		orderInfo.setSrcOrderNo("TF202003020004");
		orderInfo.setWarehouseNo("lz");
		orderInfo.setRemark("调拨出库单新建");
		detailDto1.setNum("1");
		detailDto1.setSpecNo("lz41");
		detailDto1.setUnitName("lz1");

		List<CreateTransferStockoutRequest.detailDto> detailList = new ArrayList<>();
		detailList.add(detailDto1);

		CreateTransferStockoutResponse response = stockoutAPI.createTransferOrder(orderInfo, detailList, true);
		response.toString();
	}
}
