package cn.wangdian.erp.demo;

import cn.wangdian.erp.sdk.Client;
import cn.wangdian.erp.sdk.Pager;
import cn.wangdian.erp.sdk.WdtErpException;
import cn.wangdian.erp.sdk.api.sales.TradeAPI;
import cn.wangdian.erp.sdk.api.sales.dto.TradeQueryRequest;
import cn.wangdian.erp.sdk.api.sales.dto.TradeQueryResponse;
import cn.wangdian.erp.sdk.impl.ApiFactory;
import cn.wangdian.erp.sdk.impl.DefaultClient;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class TradeQuery
{
	public static void main(String[] args) throws IOException, WdtErpException
	{
		// Client client = DefaultClient.get("wdtapi3", "test", "test");
		Client client = DefaultClient.get("wdterp30", "http://192.168.1.41:30000/", "POS",
				"c1fbdd70132de9300d23a05a5f63e150:cc169a95acdaa9ffaed4e9d59f93efaa");

		TradeAPI tradeApi = ApiFactory.get(client, TradeAPI.class);
		TradeQueryResponse response = tradeApi.query(buildRequest(), new Pager(20, 0, true));
		if (response == null || response.getTotal() <= 0)
		{
			System.out.println("No eligible results!");
			return;
		}

		System.out.println(
				"total: " + response.getTotal() + " first trade_no:" + response.getOrderList().get(0).getTradeNo());
	}

	private static TradeQueryRequest buildRequest()
	{
		TradeQueryRequest request = new TradeQueryRequest();
		// request.setSrcTid("tid-D9kO2OooUy");
		request.setTradeNo("JY201909270046");

		List statusList = new ArrayList();
		statusList.add(TradeQueryRequest.STATUS_WMS_CONFIRMED);
		// statusList.add(TradeQueryRequest.STATUS_CANCEL);
		// statusList.add(TradeQueryRequest.STATUS_WAIT_CHECK);
		// request.setStatus(StringUtils.join(statusList, ","));

		// request.setWarehouseNo("warehouse_ygg_01");
		// request.setLogisticsNo("3232323333");
		// request.setStartTime("2019-10-31 00:00:00");
		// request.setEndTime("2019-10-31 01:00:00");

		return request;
	}
}
