package cn.wangdian.erp.sdk.api.sales.dto;

import com.google.gson.annotations.SerializedName;

import java.math.BigDecimal;

public class PushSelfRequest
{
	public static class RawTrade
	{
		/**
		 * 平台状态 未确认
		 */
		public static final byte TRADE_STATUS_TO_CONFIRM = 10;
		/**
		 * 平台状态 待尾款
		 */
		public static final byte TRADE_STATUS_PART_PAID = 20;
		/**
		 * 平台状态 待发货
		 */
		public static final byte TRADE_STATUS_WAIT_CONSIGN = 30;
		/**
		 * 平台状态 部分发货
		 */
		public static final byte TRADE_STATUS_PART_CONSIGN = 40;
		/**
		 * 平台状态 已发货
		 */
		public static final byte TRADE_STATUS_CONSIGNED = 50;
		/**
		 * 平台状态 已签收
		 */
		public static final byte TRADE_STATUS_SIGNED = 60;
		/**
		 * 平台状态 已完成
		 */
		public static final byte TRADE_STATUS_COMPLETE = 70;
		/**
		 * 平台状态 已退款
		 */
		public static final byte TRADE_STATUS_REFUND = 80;
		/**
		 * 平台状态 已关闭(付款前取消)
		 */
		public static final byte TRADE_STATUS_CLOSED = 90;

		// 付款状态
		public static final byte PAY_STATUS_UNPAY = 0; // 未付款
		public static final byte PAY_STATUS_PART_PAID = 1; // 部分付款
		public static final byte PAY_STATUS_FULL_PAID = 2; // 已付款

		// 退款状态
		public static final byte REFUND_NONE = 0; // 无退款
		public static final byte REFUND_APPLY = 1; // 申请退款
		public static final byte REFUND_PART = 2; // 部分退款
		public static final byte REFUND_FULL = 3; // 全部退款

		/**
		 ** 款到发货
		 */
		public static final byte DELIVERY_TERM_DAP = 1; // 款到发货
		/**
		 * 货到付款
		 */
		public static final byte DELIVERY_TERM_COD = 2; // 货到付款(包含部分货到付款)

		public static final byte PROCESS_STATUS_WAIT_DELIVERY = 10; // 待递交
		public static final byte PROCESS_STATUS_CANCEL = 70; // 已取消

		// 1在线转帐 2现金，3银行转账，4邮局汇款 5预付款 6刷卡
		public static final byte PAY_METHOD_ONLINE = 1;
		public static final byte PAY_METHOD_CASH = 2;
		public static final byte PAY_METHOD_BANK = 3;
		public static final byte PAY_METHOD_REMITTANCE = 4;
		public static final byte PAY_METHOD_ADVANCES = 5;
		public static final byte PAY_METHOD_CARD = 5;

		// 0 不需要，1普通发票，2增值税发票
		public static final byte INVOICE_TYPE_NONE = 0;
		public static final byte INVOICE_TYPE_ORDINARY = 1;
		public static final byte INVOICE_TYPE_VAT = 2;

		private int deliveryTerm = DELIVERY_TERM_DAP;
		private byte refundStatus = REFUND_NONE;
		private byte tradeStatus = TRADE_STATUS_WAIT_CONSIGN;
		private byte payStatus = PAY_STATUS_FULL_PAID;
		private byte processStatus = PROCESS_STATUS_WAIT_DELIVERY;

		private String tid;
		// !!!
		@SerializedName("is_auto_wms")
		private Boolean autoWms;
		private String warehouseNo;
		private BigDecimal goodsCount = new BigDecimal(0.0000D);
		private Integer orderCount = 0;
		private String tradeTime;
		private Integer remarkFlag;
		private Integer consignInterval;
		private String toDeliverTime;
		private BigDecimal platformCost;
		private Integer logisticsType;
		private String endTime;
		private String payTime;
		private Byte payMethod;
		private String remark = "";
		private String payAccount = "";
		private String payId = "";
		private String receiverZip = "";
		private String receiverTelno = "";
		private String receiverName = "";
		private String receiverArea = "";
		private String receiverMobile = "";
		private String receiverAddress = "";
		private String buyerNick = "";
		private String buyerEmail = "";
		private String buyerMessage = "";
		private String buyerArea = "";
		private Byte invoiceType;
		private String invoiceContent = "";
		private String invoiceTitle = "";

		private BigDecimal receivable = BigDecimal.ZERO; // 应收金额
		private BigDecimal postAmount = BigDecimal.ZERO; // 邮费
		private BigDecimal discount = BigDecimal.ZERO; // 折扣
		private BigDecimal received = BigDecimal.ZERO; // 已收金额
		private BigDecimal codAmount = BigDecimal.ZERO; // COD金额
		private BigDecimal otherAmount = BigDecimal.ZERO; // 其他费用

		public String getWarehouseNo()
		{
			return warehouseNo;
		}

		public void setWarehouseNo(String warehouseNo)
		{
			this.warehouseNo = warehouseNo;
		}

		public int getDeliveryTerm()
		{
			return deliveryTerm;
		}

		public void setDeliveryTerm(int deliveryTerm)
		{
			this.deliveryTerm = deliveryTerm;
		}

		public byte getRefundStatus()
		{
			return refundStatus;
		}

		public void setRefundStatus(byte refundStatus)
		{
			this.refundStatus = refundStatus;
		}

		public byte getTradeStatus()
		{
			return tradeStatus;
		}

		public void setTradeStatus(byte tradeStatus)
		{
			this.tradeStatus = tradeStatus;
		}

		public byte getPayStatus()
		{
			return payStatus;
		}

		public void setPayStatus(byte payStatus)
		{
			this.payStatus = payStatus;
		}

		public byte getProcessStatus()
		{
			return processStatus;
		}

		public void setProcessStatus(byte processStatus)
		{
			this.processStatus = processStatus;
		}

		public String getTid()
		{
			return tid;
		}

		public void setTid(String tid)
		{
			this.tid = tid;
		}

		public Boolean getAutoWms()
		{
			return autoWms;
		}

		public void setAutoWms(Boolean autoWms)
		{
			this.autoWms = autoWms;
		}

		public BigDecimal getGoodsCount()
		{
			return goodsCount;
		}

		public void setGoodsCount(BigDecimal goodsCount)
		{
			this.goodsCount = goodsCount;
		}

		public Integer getOrderCount()
		{
			return orderCount;
		}

		public void setOrderCount(Integer orderCount)
		{
			this.orderCount = orderCount;
		}

		public String getTradeTime()
		{
			return tradeTime;
		}

		public void setTradeTime(String tradeTime)
		{
			this.tradeTime = tradeTime;
		}

		public Integer getRemarkFlag()
		{
			return remarkFlag;
		}

		public void setRemarkFlag(Integer remarkFlag)
		{
			this.remarkFlag = remarkFlag;
		}

		public Integer getConsignInterval()
		{
			return consignInterval;
		}

		public void setConsignInterval(Integer consignInterval)
		{
			this.consignInterval = consignInterval;
		}

		public String getToDeliverTime()
		{
			return toDeliverTime;
		}

		public void setToDeliverTime(String toDeliverTime)
		{
			this.toDeliverTime = toDeliverTime;
		}

		public BigDecimal getPlatformCost()
		{
			return platformCost;
		}

		public void setPlatformCost(BigDecimal platformCost)
		{
			this.platformCost = platformCost;
		}

		public Integer getLogisticsType()
		{
			return logisticsType;
		}

		public void setLogisticsType(Integer logisticsType)
		{
			this.logisticsType = logisticsType;
		}

		public String getEndTime()
		{
			return endTime;
		}

		public void setEndTime(String endTime)
		{
			this.endTime = endTime;
		}

		public String getPayTime()
		{
			return payTime;
		}

		public void setPayTime(String payTime)
		{
			this.payTime = payTime;
		}

		public Byte getPayMethod()
		{
			return payMethod;
		}

		public void setPayMethod(Byte payMethod)
		{
			this.payMethod = payMethod;
		}

		public String getRemark()
		{
			return remark;
		}

		public void setRemark(String remark)
		{
			this.remark = remark;
		}

		public String getPayAccount()
		{
			return payAccount;
		}

		public void setPayAccount(String payAccount)
		{
			this.payAccount = payAccount;
		}

		public String getPayId()
		{
			return payId;
		}

		public void setPayId(String payId)
		{
			this.payId = payId;
		}

		public String getReceiverZip()
		{
			return receiverZip;
		}

		public void setReceiverZip(String receiverZip)
		{
			this.receiverZip = receiverZip;
		}

		public String getReceiverTelno()
		{
			return receiverTelno;
		}

		public void setReceiverTelno(String receiverTelno)
		{
			this.receiverTelno = receiverTelno;
		}

		public String getReceiverName()
		{
			return receiverName;
		}

		public void setReceiverName(String receiverName)
		{
			this.receiverName = receiverName;
		}

		public String getReceiverArea()
		{
			return receiverArea;
		}

		public void setReceiverArea(String receiverArea)
		{
			this.receiverArea = receiverArea;
		}

		public String getReceiverMobile()
		{
			return receiverMobile;
		}

		public void setReceiverMobile(String receiverMobile)
		{
			this.receiverMobile = receiverMobile;
		}

		public String getReceiverAddress()
		{
			return receiverAddress;
		}

		public void setReceiverAddress(String receiverAddress)
		{
			this.receiverAddress = receiverAddress;
		}

		public String getBuyerNick()
		{
			return buyerNick;
		}

		public void setBuyerNick(String buyerNick)
		{
			this.buyerNick = buyerNick;
		}

		public String getBuyerEmail()
		{
			return buyerEmail;
		}

		public void setBuyerEmail(String buyerEmail)
		{
			this.buyerEmail = buyerEmail;
		}

		public String getBuyerMessage()
		{
			return buyerMessage;
		}

		public void setBuyerMessage(String buyerMessage)
		{
			this.buyerMessage = buyerMessage;
		}

		public String getBuyerArea()
		{
			return buyerArea;
		}

		public void setBuyerArea(String buyerArea)
		{
			this.buyerArea = buyerArea;
		}

		public Byte getInvoiceType()
		{
			return invoiceType;
		}

		public void setInvoiceType(Byte invoiceType)
		{
			this.invoiceType = invoiceType;
		}

		public String getInvoiceContent()
		{
			return invoiceContent;
		}

		public void setInvoiceContent(String invoiceContent)
		{
			this.invoiceContent = invoiceContent;
		}

		public String getInvoiceTitle()
		{
			return invoiceTitle;
		}

		public void setInvoiceTitle(String invoiceTitle)
		{
			this.invoiceTitle = invoiceTitle;
		}

		public BigDecimal getReceivable()
		{
			return receivable;
		}

		public void setReceivable(BigDecimal receivable)
		{
			this.receivable = receivable;
		}

		public BigDecimal getPostAmount()
		{
			return postAmount;
		}

		public void setPostAmount(BigDecimal postAmount)
		{
			this.postAmount = postAmount;
		}

		public BigDecimal getDiscount()
		{
			return discount;
		}

		public void setDiscount(BigDecimal discount)
		{
			this.discount = discount;
		}

		public BigDecimal getReceived()
		{
			return received;
		}

		public void setReceived(BigDecimal received)
		{
			this.received = received;
		}

		public BigDecimal getCodAmount()
		{
			return codAmount;
		}

		public void setCodAmount(BigDecimal codAmount)
		{
			this.codAmount = codAmount;
		}

		public BigDecimal getOtherAmount()
		{
			return otherAmount;
		}

		public void setOtherAmount(BigDecimal otherAmount)
		{
			this.otherAmount = otherAmount;
		}
	}

	public static class RawTradeOrder
	{
		public static final byte ORDER_TYPE_NORMAL = 0; // 普通货品
		public static final byte ORDER_TYPE_VIRTUAL = 1; // 虚拟货品
		public static final byte ORDER_TYPE_SERVICE = 2; // 服务

		// 退款状态
		public static final byte REFUND_STATUS_NONE = 0; // 无退款
		public static final byte REFUND_STATUS_CANCEL = 1; // 取消退款,
		public static final byte REFUND_STATUS_APPLY = 2; // 已申请退款,
		public static final byte REFUND_STATUS_AGREE = 3; // 等待退货,
		public static final byte REFUND_STATUS_WAIT_RECEIVE = 4; // 等待收货,
		public static final byte REFUND_STATUS_SUCCESS = 5; // 退款成功
		public static final byte REFUND_STATUS_DISCARD = 6; // 未付款关闭

		// 平台状态
		public static final byte PLATFORM_STATUS = 30;

		private String tid;
		private String oid;
		private Byte status;
		private Byte refundStatus;
		private Byte orderType = ORDER_TYPE_NORMAL;
		private String goodsName;
		private String goodsNo;
		private String goodsId;
		private String specNo;
		private String specId;
		private String json;
		private String specName;
		private String remark;
		private String cid = "";

		private BigDecimal num;
		private BigDecimal price;
		private BigDecimal shareDiscount;
		private BigDecimal discount;
		private BigDecimal adjustAmount;
		private BigDecimal totalAmount;
		private BigDecimal refundAmount;
		private BigDecimal shareAmount;

		public String getTid()
		{
			return tid;
		}

		public void setTid(String tid)
		{
			this.tid = tid;
		}

		public String getOid()
		{
			return oid;
		}

		public void setOid(String oid)
		{
			this.oid = oid;
		}

		public Byte getStatus()
		{
			return status;
		}

		public void setStatus(Byte status)
		{
			this.status = status;
		}

		public Byte getRefundStatus()
		{
			return refundStatus;
		}

		public void setRefundStatus(Byte refundStatus)
		{
			this.refundStatus = refundStatus;
		}

		public Byte getOrderType()
		{
			return orderType;
		}

		public void setOrderType(Byte orderType)
		{
			this.orderType = orderType;
		}

		public String getGoodsName()
		{
			return goodsName;
		}

		public void setGoodsName(String goodsName)
		{
			this.goodsName = goodsName;
		}

		public String getGoodsNo()
		{
			return goodsNo;
		}

		public void setGoodsNo(String goodsNo)
		{
			this.goodsNo = goodsNo;
		}

		public String getGoodsId()
		{
			return goodsId;
		}

		public void setGoodsId(String goodsId)
		{
			this.goodsId = goodsId;
		}

		public String getSpecNo()
		{
			return specNo;
		}

		public void setSpecNo(String specNo)
		{
			this.specNo = specNo;
		}

		public String getSpecId()
		{
			return specId;
		}

		public void setSpecId(String specId)
		{
			this.specId = specId;
		}

		public String getJson()
		{
			return json;
		}

		public void setJson(String json)
		{
			this.json = json;
		}

		public String getSpecName()
		{
			return specName;
		}

		public void setSpecName(String specName)
		{
			this.specName = specName;
		}

		public String getRemark()
		{
			return remark;
		}

		public void setRemark(String remark)
		{
			this.remark = remark;
		}

		public String getCid()
		{
			return cid;
		}

		public void setCid(String cid)
		{
			this.cid = cid;
		}

		public BigDecimal getNum()
		{
			return num;
		}

		public void setNum(BigDecimal num)
		{
			this.num = num;
		}

		public BigDecimal getPrice()
		{
			return price;
		}

		public void setPrice(BigDecimal price)
		{
			this.price = price;
		}

		public BigDecimal getShareDiscount()
		{
			return shareDiscount;
		}

		public void setShareDiscount(BigDecimal shareDiscount)
		{
			this.shareDiscount = shareDiscount;
		}

		public BigDecimal getDiscount()
		{
			return discount;
		}

		public void setDiscount(BigDecimal discount)
		{
			this.discount = discount;
		}

		public BigDecimal getAdjustAmount()
		{
			return adjustAmount;
		}

		public void setAdjustAmount(BigDecimal adjustAmount)
		{
			this.adjustAmount = adjustAmount;
		}

		public BigDecimal getTotalAmount()
		{
			return totalAmount;
		}

		public void setTotalAmount(BigDecimal totalAmount)
		{
			this.totalAmount = totalAmount;
		}

		public BigDecimal getRefundAmount()
		{
			return refundAmount;
		}

		public void setRefundAmount(BigDecimal refundAmount)
		{
			this.refundAmount = refundAmount;
		}

		public BigDecimal getShareAmount()
		{
			return shareAmount;
		}

		public void setShareAmount(BigDecimal shareAmount)
		{
			this.shareAmount = shareAmount;
		}
	}

}
